#ifndef SRE_GPULIST_H
#define SRE_GPULIST_H

// Includes ////////////////////////////////////////////////////////////////

#include "SRE_Common.h"

// Classes /////////////////////////////////////////////////////////////////

namespace SRE
{
	class Gpu;

	class GpuList
	{
	public:

		////////////////////////////////////////////////////////////////////
		// Public //////////////////////////////////////////////////////////
		////////////////////////////////////////////////////////////////////

		// Functions ///////////////////////////////////////////////////////

		bool Load();
		bool IsSaved() const;
		int Save();
		int GetCount() const;
		bool IsValidIndex(int index) const;
		bool Get(int index, Gpu &gpu) const;
		bool Set(int index, const Gpu &gpu);

		////////////////////////////////////////////////////////////////////

	private:

		////////////////////////////////////////////////////////////////////
		// Private /////////////////////////////////////////////////////////
		////////////////////////////////////////////////////////////////////

		// Constants ///////////////////////////////////////////////////////

		static const GUID GUID_DEVCLASS_DISPLAY;

		// Variables ///////////////////////////////////////////////////////

		std::vector<Gpu> gpuList;

		////////////////////////////////////////////////////////////////////
	};
}

////////////////////////////////////////////////////////////////////////////

#endif
