#ifndef UI_CLIPBOARD_H
#define UI_CLIPBOARD_H

// Includes ////////////////////////////////////////////////////////////////

#include "UI_Common.h"

// Classes /////////////////////////////////////////////////////////////////

namespace UI
{
	class Window;

	class Clipboard
	{
	public:

		////////////////////////////////////////////////////////////////////
		// Public //////////////////////////////////////////////////////////
		////////////////////////////////////////////////////////////////////

		// Functions ///////////////////////////////////////////////////////

		Clipboard(const Window &window);
		bool GetText(std::wstring &text) const;
		bool SetText(const std::wstring &text) const;

		////////////////////////////////////////////////////////////////////

	private:

		////////////////////////////////////////////////////////////////////
		// Private /////////////////////////////////////////////////////////
		////////////////////////////////////////////////////////////////////

		// Constants ///////////////////////////////////////////////////////

		static const int MaxTries;
		static const int Delay;

		// Functions ///////////////////////////////////////////////////////

		bool OpenClipboard() const;

		// Variables ///////////////////////////////////////////////////////

		HWND window;

		////////////////////////////////////////////////////////////////////
	};
}
////////////////////////////////////////////////////////////////////////////

#endif
