#ifndef UI_CONTROLS_BUTTON_H
#define UI_CONTROLS_BUTTON_H

// Includes ////////////////////////////////////////////////////////////////

#include "UI_Control.h"
#include "UI_Common.h"

// Classes /////////////////////////////////////////////////////////////////

namespace UI
{
	class Window;

	namespace Controls
	{
		class Button : public Control
		{
		public:

			////////////////////////////////////////////////////////////////////
			// Public //////////////////////////////////////////////////////////
			////////////////////////////////////////////////////////////////////

			// Constants ///////////////////////////////////////////////////////

			static const DWORD DefaultStyle = WS_TABSTOP;
			static const DWORD DefaultExStyle = 0;

			// Functions ///////////////////////////////////////////////////////

			Button(const Window &window, const std::wstring &text, DWORD style = DefaultStyle, DWORD exStyle = DefaultExStyle);

			bool IsDefault() const;
			bool SetDefault(bool value);
			bool Disable();

			////////////////////////////////////////////////////////////////////

		private:

			////////////////////////////////////////////////////////////////////
			// Private /////////////////////////////////////////////////////////
			////////////////////////////////////////////////////////////////////

			// Functions ///////////////////////////////////////////////////////

			LRESULT OnDrawItem(WPARAM wParam, LPARAM lParam);
			LRESULT OnGetDlgCode(WPARAM wParam, LPARAM lParam);
			LRESULT OnKeyDown(WPARAM wParam, LPARAM lParam);
			LRESULT OnCtlColor(WPARAM wParam, LPARAM lParam);
			LRESULT OnMouseMove(WPARAM wParam, LPARAM lParam);
			LRESULT OnLButtonDblClk(WPARAM wParam, LPARAM lParam);
			LRESULT OnMouseLeave(WPARAM wParam, LPARAM lParam);
			bool AddMessages();

			// Variables ///////////////////////////////////////////////////////

			bool hovering;
			bool outlined;

			////////////////////////////////////////////////////////////////////
		};
	}
}

////////////////////////////////////////////////////////////////////////////

#endif
